using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using System.Windows;

namespace CutomPanels
{
    class UsefullPanel:Panel
    {

        protected override Size MeasureOverride(Size availableSize)
        {
            Size mesuredSize = new Size();
            foreach (UIElement child in Children)
            {
                //każdemu dziecku przyznawany jest największy możliwy rozmiar
                child.Measure(new Size(double.PositiveInfinity,
                double.PositiveInfinity));
                //dla każdego dziecka sumowana jest potrzebna wysokości i szerokość
                mesuredSize.Height += child.DesiredSize.Height;
                mesuredSize.Width += child.DesiredSize.Width;
            }
            // rodzic zwraca potrzebną ilość miejsca
            return new Size(mesuredSize.Height, mesuredSize.Width);
        }
        protected override Size ArrangeOverride(Size finalSize)
        {
            //struktura do przechowywania pozcji ułożenia elementu
            Point arrangedSize = new Point();

            foreach (UIElement child in Children)
            {
               
                Rect childRect = new Rect(arrangedSize, child.DesiredSize);
                child.Arrange(childRect);
                // funkcja zmieniająca współrzędna punku przez dodanie wysokości i szerokości
                arrangedSize.Offset(childRect.Height, childRect.Width);
               
            }
            
            return new Size(arrangedSize.X, arrangedSize.Y);
        }

    }
}
